 /*
  * mailpath - deduce maildir from homedir
  * 
  * Author: Wietse Venema
  */

#include <stdio.h>
#include <pwd.h>

char   *strchr();

#ifndef MAILDIR
#define	MAILDIR	"/var/spool/mail"
#endif

#define home_prefix	"/home"

char   *mail_path(home, user)
char   *home;
char   *user;
{
    char   *host;
    char   *suffix;
    static char mailpath[BUFSIZ];

    /*
     * Try to deduce mailpath from home directory name. /home/svbs01b maps to
     * /var/spool/mail/svbs01/username. If that file is unavailable play safe
     * and use the standard path, which should work if the login is in the
     * home cluster.
     */

    if (strncmp(home, home_prefix, sizeof(home_prefix) - 1) == 0) {
	suffix = host = strchr(home + 1, '/') + 1;
	/* Find digits at end of server hostname. */
	while (*suffix && !isdigit(*suffix))
	    suffix++;
	/* Find suffix after end of hostname. */
	while (*suffix && isdigit(*suffix))
	    suffix++;
	sprintf(mailpath, "%s/%.*s/%s", MAILDIR,
		suffix - host, host, user);
	if (access(mailpath, 0) == 0)
	    return (mailpath);
    }
    sprintf(mailpath, "%s/%s", MAILDIR, user);
    return (mailpath);
}

#ifdef STANDALONE

main()
{
    struct passwd *pwd;

    if ((pwd = getpwuid(getuid())) == 0) {
	fprintf(stderr, "Who are you?\n");
	exit(1);
    }
    printf("%s\n", mail_path(pwd->pw_dir, pwd->pw_name));
}

#endif
